=== debian/changelog ===
eclipse-titan (7.1.1-1) unstable; urgency=high

  * New release.
    + Relaxing the C/C++ compiler version check (Closes: #954999)
    + Fix local hostname resolving (Closes: #949102)
  * Standards-Version bump to 4.5.0 (no changes needed)
  * debian/control:
    - gcc version related content removed
    - added Rules-Requires-Root field
  * debian/copyright:
    - Copyright updated
  * debian/rules:
    - gcc version related content removed

 -- Gergely Pilisi <mail.pilisig@gmail.com>  Sat, 18 Jul 2020 10:24:03 +0100
